<template>
  <div class="">
      <page-header title="Projets">
        <div slot="nav">
          <div class=" drowpdown mr-3">
              <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                  <i class="fas fa-plus-circle mr-3"></i>Exporter vers
              </button>
              <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                    <a href="javascript:void(0);"  class=" dropdown-item btn btn-sm btn-white m-b-10"><i class="fa fa-file-excel t-plus-1 text-success fa-fw fa-lg "></i> EXCEL</a>
              </div>
          </div>
        </div>
      </page-header> 
      <div class="col-md-12">
        <div :class="['card bg-transparent']" >
          <div :class="['card-header pl-0']">
              <h3 class="card-title pl-0">
                  <button  @click="showModalOnCreate"  class="ml-2 btn  btn-secondary text-xs"> 
                      <i class="fas fa-plus-circle right "></i>  Nouveau
                  </button>  
              </h3> 
          </div>
          <!-- /.card-header -->
          <!-- v-show="!NoDataForSearch && !NoDataAtAll" -->
          <div class="card-body  p-2 ">
              <div class="row">
                <projet-item class="mt-2 mr-2 col-xs-12 col-sm-6 col-md-4 col-lg-4" :entity="projets" v-for="projets in items" :key="projets.id"></projet-item>
              </div>
          </div>
          <pa @pagination:per-page="onChangeLimit" ref="pagination" :is-loading="isLoading"  :pager="[15,25,50,100]" @vuetable-pagination:change-page="onChangePage" v-show="!NoDataForSearch && !NoDataAtAll"   ></pa>

        <!-- /.card-body -->
        </div>
          <!-- <no-data-in-search v-show="pageInit" :search="searchTxt" :show="NoDataForSearch" :data-empty="NoDataAtAll"></no-data-in-search> -->
        <!-- Modal dbt -->
      <nouveau-projet @option-fetch-event='getOption'></nouveau-projet>
      <!-- Modal fin -->
      <prolongement @prolongement-done="actualiseVueTable"></prolongement>
  </div>
    </div>
</template>

<script>
   import  Vuetable from "vuetable-2/src/components/Vuetable"
   import pa from './../../components/pagination/Pagination'
   import Form from "./../../classes/Form"
   import Master from "./../Master.vue"
   import Prolongement from "./../../components/ProlongementLocation.vue"
   import ProjetItem from './ProjetItem'
   import NouveauProjet from "./NouveauProjet"
   import DocumentInput from "./../../components/DocumentInput"
   import { mapGetters } from 'vuex'


    export default {
      props: {
      },
        mixins: [Master],
        data(){
            return{
                projets : {},
                ftime:true,
                hasData:false,
                per_page:15,
                url:"api/projects",
                moreParams:{
                  filter_statut_deroulement:'',
                  filter_statut_payement:'',
                  filter:""
                },
                options:{
                  clients:[],
                  vehicules:[],
                  payements:[]
                },
                selectedClient:"",
                selectedVehicule:"",
                isLoading:false,
                form : new Form({
                  avec_chauffeur:false,
                  client_id:"",
                  vehicule_id:"",
                  date_dbt:"",
                  date_fin_prev:"",
                  nom_chauffeur:"",
                  nom_chauffeur_2:"",
                  livraison_effective:false,
                  client_est_chauffeur: false,
                  frais_livraison:0,
                  lavage_carburant:10000,
                  niveau_carburant:"",
                  nbr_jour : 0,
                  observation:"",
                  montant_ttc:"",
                  montant:"",
                  longue_duree:false,
                  zone_location:'',
                    client: {
                       nom:"",
                       prenom:"",
                       adresse:'',
                       telephone1:'',
                       ancien_client:false
                    },
                    vehicule :{
                       marque:"",
                       tvehicule:"",
                       immatriculation:"",
                       tarif:""
                    }
                }),
                columns : 
              [
                //                     {
                //     name: '__slot:extends',
                // },
                {
                    name: 'numero',
                    title:'N°',
                    titleClass: 'center aligned',
                    dataClass: 'center aligned text-uppercase',
                    sortField: 'id'
                },
                {
                name: '__slot:description',   // <----
                title: 'Description',
                titleClass: '',
                dataClass: ''
                },
                {
                name: '__slot:vehicule',   // <----
                title: 'Véhicule',
                titleClass: ' aligned',
                dataClass: ''
                },
                                                                {
                name: '__slot:payement',   // <----
                title: 'Payement',
                titleClass: 'center aligned',
                dataClass: 'center aligned'

                },
                 {
                name: '__slot:client',   // <----
                title: 'Client',
                titleClass: '',
                dataClass: ''

                },
                {
                name: '__slot:montant',   // <----
                title: 'Montant',
                titleClass: 'center aligned',
                dataClass: 'center aligned'

                },
                                                 {
                name: '__slot:statut',   // <----
                title: 'Statut',
                titleClass: 'center aligned',
                dataClass: 'center aligned'

                }
                   ,
                
                        {
                name: '__slot:actions',   // <----
                title: 'Actions',
                titleClass: 'center aligned',
                dataClass: 'center aligned'
                }
                ],
                table: {
                    tableWrapper: '',
                    tableHeaderClass: 'mb-0',
                    tableBodyClass: 'mb-0',
                    tableClass: 'table table-striped table-hover',
                    ascendingIcon: 'fa fa-chevron-up',
                    descendingIcon: 'fa fa-chevron-down',
                    ascendingClass: 'sorted-asc',
                    descendingClass: 'sorted-desc',
                    sortableIcon: 'fa fa-sort',
                    detailRowClass: 'vuetable-detail-row',
                    handleIcon: 'fa fa-bars text-secondary',
                    renderIcon(classes, options) {
                      return `<i class="${classes.join(' ')}"></span>`
                    }
                  }
            }
        },
        created()
        {
            window.event.$emit("isLoading",true)
            this.$store.dispatch('projets/init')
            this.$store.dispatch('projets/getProjets')
        },
        mounted() {
                this.$events.$on('filter-set', eventData => this.onFilterSet(eventData))
                this.$events.$on('filter-reset', e => this.onFilterReset())
                this.pageInit = true
        },
        computed:
         {
           ...mapGetters({ _pays:"params/_pays",_enterprises:"params/_enterprises",_secteurs:'params/_secteurs',_promotions:"params/_promotions",_formes_juridiques:'params/_formes_juridiques'
                           ,moreExists:'projets/moreExists',next_page_url:"projets/next_page_url",total:"projets/total"
                           ,current_page:"projets/current_page",items:"projets/_items",loading:"projets/loading",loaded:"projets/loaded"}),


           excelUrl()
           {
             return '/locations/export?format=excel&q='+this.searchTxt+'&filter_statut_deroulement='+this.moreParams.filter_statut_deroulement+"&filter_statut_payement"+this.moreParams.filter_statut_payement;
           },
           pdfUrl()
           {
             return '/locations/export?format=pdf&q='+this.searchTxt
           },
            ModalTitle ()
            {
              return  this.modeEdit ? " Modification d'une  location"  : " Ajout d'une location"
            },
            ModalAction ()
            {
              return  this.modeEdit ? " Valider"  : "Valider"
            },
            shouldGoToFirstPage()
            {
              if(this.$refs.vuetable)
              {
                return (this.$refs.vuetable.tableData.length) - 1 == 0
              } 
              else
              {
                return false
              }
            },
            filterBarIsFilled()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter != "" ? true : false
                else
                 return false
            },
            searchTxt()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter
                else
                 return ""
            },
            NoDataForSearch()
            {

              return (this.hasData == false && this.filterBarIsFilled == true ) ? true : false
            
            },

            NoDataAtAll()
            {

              return (this.hasData == false && this.filterBarIsFilled == false ) ? true : false
            
            },
              ancien_client()
            {

              return this.form.client.ancien_client==true ? true : false
            
            },
             duree()
            {
                 
              if(this.form.date_dbt!="" && this.form.date_dbt!= null && this.form.date_dbt!=undefined && this.form.date_fin_prev!="" && this.form.date_fin_prev!=null && this.form.date_fin_prev!=undefined) 
                {
                  var start = moment(this.form.date_dbt,"YYYY-MM-DD"); //todays date
                  var end = moment(this.form.date_fin_prev,"YYYY-MM-DD"); // another date
                  var duration = moment.duration(end.diff(start));
                  this.form.nbr_jour = duration.asDays();

                  return  this.form.nbr_jour
                }
              else
                return 0
            
            },
             htc()
            {
               var montant = 0
               if(this.selectedVehicule!="" && this.selectedVehicule!=null && this.selectedVehicule!=undefined )
               {
                  if(this.selectedVehicule.hasOwnProperty('tarif'))
                    if(this.selectedVehicule.tarif!=null)
                    {
                      this.form.montant = this.duree * this.selectedVehicule.tarif + this.form.frais_livraison  + this.form.lavage_carburant
                      montant = this.form.montant 

                    }
               }
               
               return montant
            },
              ttc()
            {
                  this.form.montant_ttc = this.htc * (118/100)
                 return this.monnaie(this.htc * (118/100))
            }
         },
        methods: 
        {

            // call()
            // {
            //   window.event.$emit('new-projet-event')
            // },

            filterPayementEvent(e)
            {
                 this.moreParams.filter_statut_payement= e.target.value
                 Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            filterStatutEvent(e)
            {
                 this.moreParams.filter_statut_deroulement= e.target.value
                 Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            prolongerEvent(location)
            {
              window.event.$emit('prolongement-event',location)
            },
            //Actualisation de la  vuetable apres une prolongation
             actualiseVueTable()
            {
              this.$refs.vuetable.refresh()
            },
            updateDate(e,val) 
            {
                  if(this.form.errors.has(val))
                    this.form.errors.clear(val)
                  
            },
            fixChange(e)
            {
              if(e.target.checked==false)
             {
                   this.form.client_id = ""           
             }
                            
            this.form.client.nom=""
            this.form.client.prenom=""
            this.form.client.adresse=""
            this.form.client.telephone1=""
            this.selectedClient = ""
            if(this.form.client_est_chauffeur)
            this.form.nom_chauffeur = ""

            if(this.form.errors.has('client_id') || this.form.errors.has('client.nom')|| this.form.errors.has('client.adresse') || this.form.errors.has('client.telephone1') || this.form.errors.has('client.prenom'))
            {
                this.form.errors.clear('client_id')
                this.form.errors.clear('client.nom')
                this.form.errors.clear('client.prenom')
                this.form.errors.clear('client.adresse')
                this.form.errors.clear('client.telephone1')
            }

            },
            onClientSelect(e)
            {
                this.form.client_id = e.id
                this.form.client.nom= e.nom
                this.form.client.prenom= e.prenom
                this.form.client.adresse= e.adresse
                this.form.client.telephone1= e.telephone1

              if(this.form.errors.has('client_id') || this.form.errors.has('client.nom')|| this.form.errors.has('client.adresse') || this.form.errors.has('client.telephone1') || this.form.errors.has('client.prenom'))
              {
                  this.form.errors.clear('client_id')
                  this.form.errors.clear('client.nom')
                  this.form.errors.clear('client.prenom')
                  this.form.errors.clear('client.adresse')
                  this.form.errors.clear('client.telephone1')
              }
            },
              onVehiculeSelect(e)
            {
               this.form.vehicule_id = e.id
               this.form.vehicule.marque = e.marque.libelle
               this.form.vehicule.tvehicule = e.type_vehicule.libelle
               this.form.vehicule.immatriculation = e.plaque_immatriculation
               this.form.vehicule.tarif = e.tarif

              if(this.form.errors.has('vehicule_id') )
              {
                  this.form.errors.clear('vehicule_id')
              }
            },
            formatDate: function(value, fmt) 
            {
               return  toDateFormat(value, fmt)
            },
            monnaie: function(value) 
            {
               return  numeral(value).format('0,0');
            },
            actionOnThis: function(value, fmt) 
            {
               console.log(value,fmt)
            },
            onPaginationData (paginationData) 
            {
              if(this.pageInit==false)
                 {
                   
                 }
              else
              {
                
              }
              this.hasData = paginationData.data.length > 0
              this.$refs.pagination.setPaginationData(paginationData)
            },
            onChangePage (page) 
            {
               
               this.$refs.vuetable.changePage(page)
            },
            onChangeLimit(limit)
            {
               this.per_page = parseInt(limit)
               this.$refs.vuetable.httpOptions.params.per_page = this.per_page
               this.$refs.vuetable.reload()
            },
            onLoading() 
            {

               this.isLoading = true
                if(this.ftime==false)
                {
                    $('table.vuetable').block({ 
                        message: '<div class="blockui"><span>Patientez svp</span><span><div class="kt-spinner kt-spinner--v2 kt-spinner--danger "></div></span></div>', 
                        css: { border: 'none' },
                                                
                            // styles for the overlay 
                            overlayCSS:  { 
                                backgroundColor: '#000', 
                                opacity:         0.06, 
                                cursor:          'wait' 
                            },
                    }); 
                    
                }
                this.ftime = false
            },
            onLoadingDone() 
            {
               this.isLoading = false

                 if(this.pageInit==false)
                 {
                    this.pageInit = true
                 }
                if(this.ftime==false)
                {
                    $('table.vuetable').unblock()
                }
            },
            onFilterSet (filterText) {
                this.moreParams.filter =  filterText
                
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            onFilterReset () {
                this.moreParams.filter = ""
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            onCellClicked (data,event) {
                 console.log('cellClicked: ')
                this.$refs.vuetable.toggleDetailRow(data.id)
              },
             //Verifie si un detail row est ouvert ou fermé
              isDetailRowOpened(id)
              {
                return  this.$refs.vuetable.visibleDetailRows.includes(id)
              }, 
                          //On affiche le modal pour la création
            showModalOnCreate()
            {
              window.event.$emit('new-projet-event')
              
            },
            //On affiche le modal pour l'édition
            // showModalOnEdit(entity)
            // {
               
            //     this.reset()
            //     this.modeEdit = true
            //     this.form.libelle = entity.libelle
            //     this.form.id=entity.id
            //     this.form.pays_id=entity.pays_id
            //     this.$refs['inputModal'].show()
            //  },
              //Initialisation du formulaire
              reset()
             {
                  this.modeEdit = false
                  this.isLoading = false
                  this.form.client.nom =""
                  this.form.client.adresse =""
                  this.form.client.telephone1 =""
                  this.form.client.ancien_client =false
                  this.form.vehicule.marque =""
                  this.form.vehicule.tvehicule =""
                  this.form.vehicule.immatriculation =""
                  this.form.vehicule.tarif =""
                  this.form.avec_chauffeur = false
                  this.form.client_est_chauffeur = false
                  this.form.longue_duree = false

                  this.selectedClient = ""
                  this.selectedVehicule = ""
                  this.form.date_dbt = ""
                  this.form.date_fin_prev = ""
                  this.form.nom_chauffeur = ""
                  this.form.nom_chauffeur_2 = ""
                  this.form.zone_location = ""
                  this.form.livraison_effective = false
                  this.form.errors.clearAll()
                  this.$refs['inputModal'].hide()

                  if(this.moreParams.hasOwnProperty('filter'))
                  this.moreParams.filter=""
             },
             
              fetchOptions()
             {
               axios.get("/api/dispatcher/options/locations").then((response) => 
                { 
                      
                      //envoie un event pour signifier le chargement des options
                      this.$emit('initOption');
                     // this.pageInit =true
                },
                (error) =>
                {
                  this.isLoading = false
                });


                 axios.get("/projets").then((response) => 
                { 
                  this.projets = response.data;
                  //envoie un event pour signifier le chargement des options
                  this.$emit('initOption');
                  // this.pageInit =true
                },
                (error) =>
                {
                  this.isLoading = false
                });
             },
                          //Gere l'action du formulaire
             onSubmit()
             {
                 //On réinitialise le chargement
                this.isLoading = true
                //Si on edite pas
                if(!this.modeEdit)
                  //on ajoute un nouveau
                   this.add()
                else 
                //alors on actualise
                  this.update()
             },
            //Ajoute une marque dans la BDD
            add()
            {
                //Requête ajax
                this.form.post(this.url).then((response) => 
                { 
                  console.log(response) 
                  if(response.success)
                  {
                  this.reset()
                  // on ramène les données sur la page 1
                  this.$refs.vuetable.refresh()
                  flash("<span>Enregistré <strong>avec succès</strong></span>")
                  }
                  else
                  {
                        flash("<span>Enregistrement <strong> impossible</strong></span>","error")
                        this.reset()

                  }


                },
                (error) =>
                {
                  this.isLoading = false
                });                  
            },
            //Actualise  un marque dans la BDD
            update()
            {
              
                //Requête ajax
                this.form.patch(this.url+"/"+this.form.id).then((value) => 
                {
                  
                   // on rafraichit la page des données actuelle
                  this.$refs.vuetable.reload()
                  //On remet à zero notre formulaire
                  this.reset()
                  //on affiche le message 
                  flash("<span>Modifié <strong>avec succès</strong></span>")
                  

                },
                (error) =>
                {
                  this.isLoading = false
                  //on affiche le message 
                  flash("<span>Ajout <strong>impossible</strong></span>","danger")
                });                  
            },
             excel()
             {
               var vm = this
                axios.get("/api/locations/export",{params:this.moreParams}).then((response) => 
                { 
                    
                    const url = window.URL.createObjectURL(new Blob([response.data]));
                    const link = document.createElement('a');
                    link.href = url;
                    link.setAttribute('download','locations.xlsx');
                    document.body.appendChild(link);
                    link.click();
                      
                },
                (error) =>
                {
                  this.isLoading = false
                });
             },
            getOption(e)
             {
               //this.options.secteurs = e
             },
            remove(e)
             {
                    this.isLoading = true
                    alertConfirm("Cette action est <b>irréversible</b>, souhaitez-vous vraiment <b>supprimer</b> cette location de manière définitive ?","Suppréssion d'une location")
                    .then(result => {
                        if(result)
                        {
                           axios.delete("api/locations/"+e.id).then((response) => 
                            { 


                               // on rafraichit la page de donnée actuelle
                              !this.shouldGoToFirstPage ? this.$refs.vuetable.reload() : this.$refs.vuetable.refresh()

                              flash("<span>Supprimé <strong>avec succès</strong></span>")
                              this.isLoading = false

                            },
                            (error) =>
                            {
                              this.isLoading = false
                            });
                        }
                    })
                    .catch(error => {
                        reject(error);
                    });

                

             },
       },
        components:
        {
            ProjetItem,
            NouveauProjet,
            DocumentInput,
            Vuetable,
            Prolongement,
            pa
        },
        watch:
        {
          "form.livraison_effective":function(value)
          {
            if(value==true)
             this.form.frais_livraison = 5000
             else
              this.form.frais_livraison = 0
          },
         "form.niveau_carburant":function(value)
          {
            if(this.form.errors.has('niveau_carburant'))
            {
              this.form.errors.clear('niveau_carburant')
            }
          },
          "form.client_est_chauffeur":function(value)
          {
            if(value==true)
             {
               if(this.form.client.nom!="" && this.form.client.prenom!="")
               {
                 this.form.nom_chauffeur = this.form.client.prenom+" "+this.form.client.nom
                if(this.form.errors.has('nom_chauffeur'))
                {
                  this.form.errors.clear('nom_chauffeur')
                }
               }
             }
             else
             {
               this.form.nom_chauffeur = ""
                if(this.form.errors.has('nom_chauffeur'))
                {
                  this.form.errors.clear('nom_chauffeur')
                }
             }
          }
        }
    }
</script>
<style lang="scss" scoped>
  #my-modal input[type="text"],#my-modal select
  {
        height: 30px;
        min-height: 30px;
  }
  .form-group {
    margin-bottom: 1.6rem;
}
#my-modal .modal-body
{
  overflow-x: hidden !important;
}
.modal-dialog-scrollable .modal-body {
      overflow-y: auto;
        overflow-x: hidden !important;

      
}
.card-tools .filter
{
  flex:1;
  margin-right: 10px;
}
.card-tools .filter-search
{
  flex:1;
}

.w-100 {
    width: 70% !important;
}
</style>